unit FORM_FILTER;

{APPTYPE CONSOLE}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

TYPE ARRAY_OF_1000_BYTE=ARRAY[0..999] OF BYTE;
VAR ARRAY_RX:ARRAY_OF_1000_BYTE;
VAR ARRAY_FILLED:BOOLEAN;

type
  TForm1 = class(TForm)
    Display_Level: TGroupBox;
    The_Level: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Timer1: TTimer;
    Filter: TSpeedButton;
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FilterClick(Sender: TObject);  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
FUNCTION ARRAY_RX_FILLED__F6CTE_DLL_RX_SOUND_CARD_DELPHI_V_1(VAR LE_ARRAY_RX:ARRAY_OF_1000_BYTE):BOOLEAN;stdcall;
 external 'F6CTE_DLL_RX_SOUND_CARD_V_1.DLL';
FUNCTION STOP_RX__F6CTE_DLL_RX_SOUND_CARD_DELPHI_V_1:BOOLEAN;stdcall;
 external 'F6CTE_DLL_RX_SOUND_CARD_V_1.DLL';

VAR S_N_1:LONGINT=0;{for the lowpass filter}
VAR FILTER_ON:BOOLEAN=FALSE;{filter intially "Off"}

{*********}

procedure TForm1.Timer1Timer(Sender: TObject);
VAR COUNTER:LONGINT;
VAR LEVEL:BYTE;{between 0 to 255}
VAR DATA:LONGINT;{between -255 to 255}
VAR SUM:LONGINT;
VAR AVERAGE:LONGINT;{between 0 to 100}
VAR STRING_AVERAGE:STRING;
VAR E_N,S_N:LONGINT;{for the lowpass filter}
VAR ARRAY_OUTPUT:ARRAY_OF_1000_BYTE;
begin
 ARRAY_FILLED:=ARRAY_RX_FILLED__F6CTE_DLL_RX_SOUND_CARD_DELPHI_V_1(ARRAY_RX);
 {a data string is ready to be managed}
 IF ARRAY_FILLED=TRUE THEN
 BEGIN
  {the average level is computed and then displayed}
  SUM:=0;{initialization}

  {calculation of the ouput level of the lowpass filter s(n) = s(n-1).0,637 + e(n).0,363}
  {for the oldest (COUNTER:=0) to the newest (COUNTER:=255)}
  FOR COUNTER:=0 TO 999 DO
  BEGIN
   E_N:=ARRAY_RX[COUNTER]-127;{for an average signal about 0}
   IF FILTER_ON=TRUE THEN S_N:=(S_N_1*637+E_N*363) DIV 1000 ELSE S_N:=E_N;
   IF S_N>128 THEN S_N:=128 ELSE IF S_N<-127 THEN S_N:=-127;{limitations}
   S_N_1:=S_N;{memorization of S_N_1}
   ARRAY_OUTPUT[COUNTER]:=S_N+127;{result S_N memorized in an array and put in a 0..255 scale}
  END;

  {***************OUTPUT LEVEL AVERAGE CALCULATION**************}
  {for the oldest (COUNTER:=0) to the newest (COUNTER:=255)}
  FOR COUNTER:=0 TO 999 DO
  BEGIN
   LEVEL:=ARRAY_OUTPUT[COUNTER];
   DATA:=2*LEVEL-255;
   INC(SUM,ABS(DATA));
  END;

  {calculation of the average}
  AVERAGE:=SUM DIV 1000;
  {normalization of the average to 100 %}
  AVERAGE:=(AVERAGE * 100) DIV 255;

  {display of the average}
  STR(AVERAGE,STRING_AVERAGE);
  The_Level.Caption:=STRING_AVERAGE+' %';
 END;
end;

{*********}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 STOP_RX__F6CTE_DLL_RX_SOUND_CARD_DELPHI_V_1;
end;

{*********}

procedure TForm1.FilterClick(Sender: TObject);
begin
 IF Filter.Down=TRUE THEN FILTER_ON:=TRUE ELSE FILTER_ON:=FALSE;
end;

end.
